//this file is part of eMule
//Copyright (C)2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// MOD BEGIN netfinity:
#include "NetF.h"
#include "partfile.h"
// MOD END

float CClientCredits::GetScoreRatio(uint32 dwForIP) const
{
	// check the client ident status
	if ( ( GetCurrentIdentState(dwForIP) == IS_IDFAILED || GetCurrentIdentState(dwForIP) == IS_IDBADGUY || GetCurrentIdentState(dwForIP) == IS_IDNEEDED) && theApp.clientcredits->CryptoAvailable() ){
		// bad guy - no credits for you
		return 1;
	}

	// Modified by netfinity
	double DownloadedTotal = GetDownloadedTotal().GetValue();
	double UploadedTotal = GetUploadedTotal().GetValue();

	// Reduce effects of credit shaping!
	if (theNetF.m_bFreshmanCredits && DownloadedTotal < PARTSIZE && UploadedTotal < PARTSIZE)
	{
		// A high value here will prevent CS from building communities
		//  but will also benefit identity changing leecher mods
		// Suggested value is between 1.0 - 2.0
		return 1.5f;
	}
	else if (DownloadedTotal < 1000000.0)
		return 1.0f;

	float result = 0;
	if (UploadedTotal < 1.0)
		result = 10;
	else
		result = ((DownloadedTotal * 2.0)/ UploadedTotal);
	float result2 = 0;
	result2 = (DownloadedTotal / 1048576.0);
	result2 += 2;
	result2 = sqrt(result2);

	if (result > result2)
		result = result2;

	if (result < 1)
		result = 1;
	else if (result > 10)
		result = 10;

	return result;
}
