//this file is part of eMule
//Copyright (C)2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

void CUpDownClient::DrawStatusBar(CDC* dc, LPCRECT rect, bool onlygreyrect, bool  bFlat, CClientFileStatus* fileStatus) const
{
	COLORREF crNeither;
	if(bFlat) {
		crNeither = RGB(224, 224, 224);
	} else if(fileStatus != m_pDownFileStatus) { // netfinity: Show A4AF sources in shades of red
		crNeither = RGB(240/2+40, 240/2, 240/2);
	} else {
		crNeither = RGB(240, 240, 240);
	}

	CPartFile* file = NULL;
	if (fileStatus != NULL)
		file = fileStatus->GetPartFile();

	s_StatusBar.SetFileSize(file ? file->GetFileSize() : 0);
	s_StatusBar.SetHeight(rect->bottom - rect->top);
	s_StatusBar.SetWidth(rect->right - rect->left);
	s_StatusBar.Fill(crNeither);

	if(!file || !fileStatus || (fileStatus && fileStatus->IsUnknownFile()))
	{
		if (theApp.m_brushBackwardDiagonal.m_hObject)
		{
			int iOldBkColor = dc->SetBkColor(RGB(100, 100, 100));
			dc->FillRect(rect, &theApp.m_brushBackwardDiagonal);
			dc->SetBkColor(iOldBkColor);
		}
		else
			s_StatusBar.Draw(dc, rect->left, rect->top, bFlat);
		return;
	}
	else if (fileStatus->IsDeletedFile())
	{
		if (theApp.m_brushBackwardDiagonal.m_hObject)
		{
			int iOldBkColor = dc->SetBkColor(RGB(255, 0, 0));
			dc->FillRect(rect, &theApp.m_brushBackwardDiagonal);
			dc->SetBkColor(iOldBkColor);
		}
		else
			s_StatusBar.Draw(dc, rect->left, rect->top, bFlat);
		return;
	}
	else if (!onlygreyrect)
	{
		COLORREF crBoth;
		COLORREF crClientOnly;
		COLORREF crPending;
		COLORREF crNextPending;
        COLORREF crClientPartial; // enkeyDev: ICS
        COLORREF crHidden; // netfinity: Anti HideOS
		if(bFlat) {
			crBoth = RGB(0, 0, 0);
			crNeither = RGB(224, 224, 224);
			crClientOnly = RGB(0, 100, 255);
			crPending = RGB(0,150,0);
			crNextPending = RGB(255,208,0);
			crClientPartial = RGB(170,50,224); // enkeyDev: ICS
			crHidden = RGB(150,240,240); // netfinity: Anti HideOS
		// MOD BEGIN netfinity: Show A4AF sources in shades of red 
		} else if(fileStatus != m_pDownFileStatus) {
			crBoth = RGB(104/2+40, 104/2, 104/2);
			crNeither = RGB(240/2+40, 240/2, 240/2);
			crClientOnly = RGB(0/2+40, 100/2, 255/2);
			crPending = RGB(0/2+40, 150/2, 0/2);
			crNextPending = RGB(255/2+40,208/2,0/2);
			crClientPartial = RGB(170/2+40,50/2,224/2); // enkeyDev: ICS
			crHidden = RGB(150/2+40,240/2,240/2); // netfinity: Anti HideOS
		// MOD END netfinity
		} else {
			crBoth = RGB(104, 104, 104);
			crNeither = RGB(240, 240, 240);
			crClientOnly = RGB(0, 100, 255);
			crPending = RGB(0, 150, 0);
			crNextPending = RGB(255,208,0);
			crClientPartial = RGB(170,50,224); // enkeyDev: ICS
			crHidden = RGB(150,240,240); // netfinity: Anti HideOS
		}

		char* pcNextPendingBlks = NULL;
		if (m_nDownloadState == DS_DOWNLOADING && fileStatus == m_pDownFileStatus){
			pcNextPendingBlks = new char[fileStatus->GetPartCount()];
			memset(pcNextPendingBlks, 'N', fileStatus->GetPartCount()); // do not use '_strnset' for uninitialized memory!
			for (POSITION pos = m_PendingBlocks_list.GetHeadPosition(); pos != 0; ){
				UINT uPart = m_PendingBlocks_list.GetNext(pos)->block->StartOffset / PARTSIZE;
				if (uPart < fileStatus->GetPartCount())
					pcNextPendingBlks[uPart] = 'Y';
			}
		}

		for (uint32 i = 0;i < fileStatus->GetPartCount();i++)
		{
			uint32 uEnd;
			if (PARTSIZE*(i+1) > file->GetFileSize())
				uEnd = file->GetFileSize();
			else
				uEnd = PARTSIZE*(i+1);

			if (fileStatus->IsCompletePart(i))
			{
				if (file->IsComplete(PARTSIZE*i,PARTSIZE*(i+1)-1))
					s_StatusBar.FillRange(PARTSIZE*i, uEnd, crBoth);
				else if (m_nDownloadState == DS_DOWNLOADING && m_nLastBlockOffset >= PARTSIZE*i && m_nLastBlockOffset < uEnd  && fileStatus == m_pDownFileStatus)
					s_StatusBar.FillRange(PARTSIZE*i, uEnd, crPending);
				else if (pcNextPendingBlks != NULL && pcNextPendingBlks[i] == 'Y')
					s_StatusBar.FillRange(PARTSIZE*i, uEnd, crNextPending);
				else
					s_StatusBar.FillRange(PARTSIZE*i, uEnd, crClientOnly);
			}
			// MOD BEGIN netfinity: Anti HideOS
			else if (fileStatus->IsSeenPart(i))
			{			
				if (file->IsComplete(PARTSIZE*i,PARTSIZE*(i+1)-1))
					s_StatusBar.FillRange(PARTSIZE*i, uEnd, crBoth);
				else if (m_nDownloadState == DS_DOWNLOADING && m_nLastBlockOffset >= PARTSIZE*i && m_nLastBlockOffset < uEnd  && fileStatus == m_pDownFileStatus)
					s_StatusBar.FillRange(PARTSIZE*i, uEnd, crPending);
				else if (pcNextPendingBlks != NULL && pcNextPendingBlks[i] == 'Y' && fileStatus == m_pDownFileStatus)
					s_StatusBar.FillRange(PARTSIZE*i, uEnd, crNextPending);
				else
					s_StatusBar.FillRange(PARTSIZE*i, uEnd, crHidden);
			}
			// MOD END netfinity
			// enkeyDev: ICS
			else if (fileStatus->IsIncompletePart(i))
			{
				s_StatusBar.FillRange(PARTSIZE*i, uEnd, crClientPartial);
			}
			// <--- enkeyDev: ICS
		}
		delete[] pcNextPendingBlks;
	}
	s_StatusBar.Draw(dc, rect->left, rect->top, bFlat);
} 

// enkeyDEV: ICS
void CUpDownClient::MOD_ProcessFileIncStatus(CSafeMemFile* data,uint32 size, bool readHash, CClientFileStatus* fileStatus)
{
	if (readHash){
		uchar cfilehash[16];
		data->ReadHash16(cfilehash);
		fileStatus = m_FileStatusList.FindFileByHash(cfilehash);
	//if ( (!reqfile) || md4cmp(cfilehash,reqfile->GetFileHash())){
	//	throw CString(GetResString(IDS_ERR_WRONGFILEID)+ _T(" (ProcessFileIncStatus)"));	
	//}
	}
	CPartFile* file = fileStatus->GetPartFile();
	if (fileStatus == NULL)
	{
		throw CString(_T("CUpDownClient::MOD_ProcessFileIncStatus; fileStatus == NULL"));
	}
	if (file == NULL)
	{
		throw CString(_T("CUpDownClient::MOD_ProcessFileIncStatus; file == NULL"));
	}
	uint16 partCount = data->ReadUInt16();
	if (!partCount){
		partCount = file->GetPartCount();
	}
	else{
		if (file->GetPartCount() != partCount){
			throw GetResString(IDS_ERR_WRONGPARTNUMBER);
		}
		uint16 done = 0;
		while (done != partCount){
			uint8 toread = data->ReadUInt8();
			for (sint32 i = 0;i != 8;i++){
				if ((toread >> i) & 1)
					fileStatus->SetIncompletePart(done);
				else
					fileStatus->ClearIncompletePart(done);

				done++;
				if (done == partCount)
					break;
			}
		}
	}

	file->MOD_NewSrcIncPartsInfo();
}
// <--- enkeyDEV: ICS

void CUpDownClient::ProcessFileStatus(bool bUdpPacket, CSafeMemFile* data, CPartFile* file)
{
	CClientFileStatus*	pFileStatus = m_FileStatusList.FindFile(file); // netfinity: New style part status records
	if(pFileStatus == NULL)
		throw CString(_T("ProcessFileStatus; pFileStatus == NULL (file not requested)"));

	uint16 nED2KPartCount = data->ReadUInt16();
	bool bPartsNeeded = false;
	int iNeeded = 0;
	if (!nED2KPartCount)
	{
		pFileStatus->SetCompleteFile();
		//fileStatus->SetPartCount(file->GetPartCount());
		bPartsNeeded = true;
		m_bCompleteSource = true;
		if (bUdpPacket ? (thePrefs.GetDebugClientUDPLevel() > 0) : (thePrefs.GetDebugClientTCPLevel() > 0))
		{
			for (int i = 0; i < pFileStatus->GetPartCount(); i++)
			{
				if (!file->IsComplete(i*PARTSIZE,((i+1)*PARTSIZE)-1))
					iNeeded++;
			}
		}
	}
	else
	{
		if (file->GetED2KPartCount() != nED2KPartCount)
		{
			CString strError;
			strError.Format(_T("%s; wrong part number recv=%u  expected=%u  %s"), _T(__FUNCTION__), nED2KPartCount, file->GetED2KPartCount(), DbgGetFileInfo(file->GetFileHash()));
			throw strError;
		}
		uint16 partCount = file->GetPartCount();
		//fileStatus->SetPartCount(partCount);
		m_bCompleteSource = false;
		uint16 done = 0;
		// MOD BEGIN netfinity: Anti HideOS
		bool	checkSeenParts = false;
		if (theNetF.m_bDownloadHidden && MOD_IsPartialSource()) //m_abySeenPartStatus)
			checkSeenParts = true;
		// MOD END netfinity
		while (done != partCount)
		{
			uint8 toread = data->ReadUInt8();
			for (sint32 i = 0;i != 8;i++)
			{
				if((toread >> i) & 1)
					pFileStatus->SetCompletePart(done); // netfinity: New style part status records
				else
					pFileStatus->ClearCompletePart(done); // netfinity: New style part status records
				// netfinity: Anti HideOS
				if ((checkSeenParts ? pFileStatus->IsSeenPart(done) : pFileStatus->IsCompletePart(done)))
				{
					if (!file->IsComplete(done*PARTSIZE,((done+1)*PARTSIZE)-1)){
 						bPartsNeeded = true;
						iNeeded++;
					}
				}
				done++;
				if (done == partCount)
					break;
			}
		}
	}
	
	if (bUdpPacket ? (thePrefs.GetDebugClientUDPLevel() > 0) : (thePrefs.GetDebugClientTCPLevel() > 0))
	{
		uint16 partCount = file->GetPartCount();
		TCHAR* psz = new TCHAR[partCount + 1];
		for (int i = 0; i < partCount; i++)
			psz[i] = pFileStatus->IsCompletePart(i) ? _T('#') : _T('.');
		psz[i] = _T('\0');
		Debug(_T("  Parts=%u  %s  Needed=%u\n"), partCount, psz, iNeeded);
		delete[] psz;
	}

	UpdateDisplayedInfo();
	file->UpdateAvailablePartsCount();

	if(bPartsNeeded)
		pFileStatus->SetHasNeededParts();
	else
		pFileStatus->SetNoNeededParts();
	// NOTE: This function is invoked from TCP and UDP socket!
	if (!bUdpPacket)
	{
		if (file == GetRequestFile() && GetDownloadState() != DS_DOWNLOADING)
		{
			if (!bPartsNeeded)
				SetDownloadState(DS_NONEEDEDPARTS);
			//If we are using the eMule filerequest packets, this is taken care of in the Multipacket!
			else if (file->hashsetneeded)
			{
				if (socket)
				{
					if (thePrefs.GetDebugClientTCPLevel() > 0)
						DebugSend("OP__HashSetRequest", this, (char*)file->GetFileHash());
					Packet* packet = new Packet(OP_HASHSETREQUEST,16);
					md4cpy(packet->pBuffer,file->GetFileHash());
					theStats.AddUpDataOverheadFileRequest(packet->size);
					socket->SendPacket(packet, true, true);
					SetDownloadState(DS_REQHASHSET);
					m_fHashsetRequesting = 1;
					file->hashsetneeded = false;
				}
				else
					ASSERT(0);
			}
			else
			{
				SendStartupLoadReq();
			}
		}
	}
	else
	{
		if (file == GetRequestFile()&& GetDownloadState() != DS_DOWNLOADING)
		{
			if (!bPartsNeeded)
				SetDownloadState(DS_NONEEDEDPARTS);
			else
				SetDownloadState(DS_ONQUEUE);
		}
	}
	file->UpdatePartsInfo();
}

void CUpDownClient::ProcessFileInfo(CSafeMemFile* data, CPartFile* file)
{
	// 26-Jul-2003: removed requesting the file status for files <= PARTSIZE for better compatibility with ed2k protocol (eDonkeyHybrid).
	// if the remote client answers the OP_REQUESTFILENAME with OP_REQFILENAMEANSWER the file is shared by the remote client. if we
	// know that the file is shared, we know also that the file is complete and don't need to request the file status.
	CClientFileStatus*	pFileStatus = m_FileStatusList.FindFile(file); // netfinity: New style part status records
	if(pFileStatus == NULL)
		throw CString(_T(__FUNCTION__) _T("; pFileStatus == NULL"));

	pFileStatus->SetFileName(data->ReadString(GetUnicodeSupport()));
	if (file->GetPartCount() == 1)
	{
		uint16 partCount = file->GetPartCount();
		m_bCompleteSource = true;

		if (thePrefs.GetDebugClientTCPLevel() > 0)
		{
		    int iNeeded = 0;
		    for (int i = 0; i < partCount; i++)
			    if (!file->IsComplete(i*PARTSIZE,((i+1)*PARTSIZE)-1))
				    iNeeded++;
			char* psz = new char[partCount + 1];
			for (int i = 0; i < partCount; i++)
				psz[i] = pFileStatus->IsCompletePart(i) ? '#' : '.';
			psz[i] = '\0';
			Debug(_T("  Parts=%u  %hs  Needed=%u\n"), partCount, psz, iNeeded);
			delete[] psz;
		}
		UpdateDisplayedInfo();
		file->UpdateAvailablePartsCount();
		pFileStatus->SetHasNeededParts();
		// even if the file is <= PARTSIZE, we _may_ need the hashset for that file (if the file size == PARTSIZE)
		if (file->hashsetneeded)
		{
			if (socket)
			{
				Packet* packet = new Packet(OP_HASHSETREQUEST,16);
				md4cpy(packet->pBuffer,file->GetFileHash());
				theStats.AddUpDataOverheadFileRequest(packet->size);
				socket->SendPacket(packet,true,true);
				SetDownloadState(DS_REQHASHSET);
				m_fHashsetRequesting = 1;
				file->hashsetneeded = false;
			}
			else
				ASSERT(0);
		}
		else
		{
			if (pFileStatus == m_pDownFileStatus && GetDownloadState() != DS_DOWNLOADING) // netfinity: Only request for download, when it's the wanted file
				SendStartupLoadReq();
		}
		file->UpdatePartsInfo();
	}
}

void CUpDownClient::SendFileRequest()
{
	try{
    // normally asktime has already been reset here, but then SwapToAnotherFile will return without much work, so check to make sure
    SwapToAnotherFile(_T("A4AF check before tcp file reask. CUpDownClient::SendFileRequest()"), true, false, false, NULL, true, true); // ZZ:DownloadManager

	ASSERT(m_pDownFileStatus != NULL);

	CPartFile* reqfile = GetRequestFile();
	if(!reqfile)
		return;

	AddAskedCountDown();

	// MOD BEGIN netfinity: CFS - Experimental A4AF status collecting
	if( SupportMultiPacket() )
	{
		for(POSITION pos = m_FileStatusList.GetHeadPosition(); pos != 0;)
		{
			CClientFileStatus* pFileStatus = m_FileStatusList.GetNext(pos);
			if (pFileStatus && pFileStatus != m_pDownFileStatus)
			{
				CPartFile* pFile = pFileStatus->GetPartFile();
				if (pFile
					&& !pFile->IsStopped()
					&& !pFileStatus->IsDeletedFile()
					&& (pFileStatus->GetTimeUntilReask() == 0
						|| pFileStatus->GetFileName().IsEmpty()
					   )
				   )
				{
					CSafeMemFile dataFileReq(16+16);
					dataFileReq.WriteHash16(pFile->GetFileHash());
					if ( pFileStatus->GetFileName().IsEmpty() )
					{
						dataFileReq.WriteUInt8(OP_REQUESTFILENAME);
						//Extended information
						if( GetExtendedRequestsVersion() > 0 )
							pFile->WritePartStatus(&dataFileReq);
						if( GetExtendedRequestsVersion() > 1 )
							pFile->WriteCompleteSourcesCount(&dataFileReq);
					}
					if (pFile->GetPartCount() > 1)
						dataFileReq.WriteUInt8(OP_SETREQFILEID);
					if( IsSourceRequestAllowed() ) // netfinity: This part need some work!
					{
						dataFileReq.WriteUInt8(OP_REQUESTSOURCES);
						pFile->SetLastAnsweredTimeTimeout();
						SetLastAskedForSources();
						if ( thePrefs.GetDebugSourceExchange() )
							AddDebugLogLine(false, _T("SXSend: Client source request; %s, File=\"%s\""), DbgGetClientInfo(), pFile->GetFileName());
					}
					if (IsSupportingAICH() && pFileStatus->GetFileAICHHash() == NULL){
						if (thePrefs.GetDebugClientTCPLevel() > 0)
							DebugSend("OP__MPAichFileHashReq", this, (char*)reqfile->GetFileHash());
						dataFileReq.WriteUInt8(OP_AICHFILEHASHREQ);
					}

					if (thePrefs.GetDebugClientTCPLevel() > 0)
						DebugSend("OP__MultiPacket", this, (char*)pFile->GetFileHash());
					Packet* packet = new Packet(&dataFileReq, OP_EMULEPROT);
					packet->opcode = OP_MULTIPACKET;
					theStats.AddUpDataOverheadFileRequest(packet->size);
					socket->SendPacket(packet, true);
				    pFileStatus->SetDownAsked();
				}
			}
		}
	}
	// MOD END netfinity

	CSafeMemFile dataFileReq(16+16);
	dataFileReq.WriteHash16(reqfile->GetFileHash());

	if( SupportMultiPacket() )
	{
		// netfinity: CFS - Save some overhead by not asking for the filename
		if (reqfile->GetPartCount() <= 1
			|| (m_pDownFileStatus->GetFileName().IsEmpty() && !IsSourceRequestAllowed())
		   )
		{
			dataFileReq.WriteUInt8(OP_REQUESTFILENAME);
			//Extended information
			if( GetExtendedRequestsVersion() > 0 )
				reqfile->WritePartStatus(&dataFileReq);
			if( GetExtendedRequestsVersion() > 1 )
				reqfile->WriteCompleteSourcesCount(&dataFileReq);
		}
		if (reqfile->GetPartCount() > 1)
			dataFileReq.WriteUInt8(OP_SETREQFILEID);
		if( IsEmuleClient() )
		{
			SetRemoteQueueFull( true );
			SetRemoteQueueRank(0);
		}	
		if(IsSourceRequestAllowed())
		{
			dataFileReq.WriteUInt8(OP_REQUESTSOURCES);
			reqfile->SetLastAnsweredTimeTimeout();
			SetLastAskedForSources();
			if (thePrefs.GetDebugSourceExchange())
				AddDebugLogLine(false, _T("SXSend: Client source request; %s, File=\"%s\""), DbgGetClientInfo(), reqfile->GetFileName());
        }
		if (IsSupportingAICH() && m_pDownFileStatus->GetFileAICHHash() == NULL){
			if (thePrefs.GetDebugClientTCPLevel() > 0)
				DebugSend("OP__MPAichFileHashReq", this, (char*)reqfile->GetFileHash());
			dataFileReq.WriteUInt8(OP_AICHFILEHASHREQ);
		}

		if (thePrefs.GetDebugClientTCPLevel() > 0)
			DebugSend("OP__MultiPacket", this, (char*)reqfile->GetFileHash());
		Packet* packet = new Packet(&dataFileReq, OP_EMULEPROT);
		packet->opcode = OP_MULTIPACKET;
		theStats.AddUpDataOverheadFileRequest(packet->size);
		socket->SendPacket(packet, true);
	}
	else
	{
		//This is extended information
		if( GetExtendedRequestsVersion() > 0 ){
			reqfile->WritePartStatus(&dataFileReq);
		}
		if( GetExtendedRequestsVersion() > 1 ){
			reqfile->WriteCompleteSourcesCount(&dataFileReq);
		}
		if (thePrefs.GetDebugClientTCPLevel() > 0)
			DebugSend("OP__FileRequest", this, (char*)reqfile->GetFileHash());
		Packet* packet = new Packet(&dataFileReq);
		packet->opcode=OP_REQUESTFILENAME;
		theStats.AddUpDataOverheadFileRequest(packet->size);
		socket->SendPacket(packet, true);
	
		// 26-Jul-2003: removed requesting the file status for files <= PARTSIZE for better compatibility with ed2k protocol (eDonkeyHybrid).
		// if the remote client answers the OP_REQUESTFILENAME with OP_REQFILENAMEANSWER the file is shared by the remote client. if we
		// know that the file is shared, we know also that the file is complete and don't need to request the file status.
		if (reqfile->GetPartCount() > 1)
		{
			if (thePrefs.GetDebugClientTCPLevel() > 0)
				DebugSend("OP__SetReqFileID", this, (char*)reqfile->GetFileHash());
		    CSafeMemFile dataSetReqFileID(16);
			dataSetReqFileID.WriteHash16(reqfile->GetFileHash());
		    packet = new Packet(&dataSetReqFileID);
		    packet->opcode = OP_SETREQFILEID;
		    theStats.AddUpDataOverheadFileRequest(packet->size);
		    socket->SendPacket(packet, true);
		}
	
		if( IsEmuleClient() )
		{
			SetRemoteQueueFull( true );
			SetRemoteQueueRank(0);
		}	
		if(IsSourceRequestAllowed()) 
		{
		    if (thePrefs.GetDebugClientTCPLevel() > 0){
			    DebugSend("OP__RequestSources", this, (char*)reqfile->GetFileHash());
			    if (!GetLastAskedForSources().IsTickSet())
				    Debug(_T("  first source request\n"));
			    else
				    Debug(_T("  last source request was before %s\n"), CastSecondsToHM(GetLastAskedForSources().Elapsed()));
		    }
			reqfile->SetLastAnsweredTimeTimeout();
			Packet* packet = new Packet(OP_REQUESTSOURCES,16,OP_EMULEPROT);
			md4cpy(packet->pBuffer,reqfile->GetFileHash());
			theStats.AddUpDataOverheadSourceExchange(packet->size);
			socket->SendPacket(packet,true,true);
			SetLastAskedForSources();
			if (thePrefs.GetDebugSourceExchange())
				AddDebugLogLine(false, _T("SXSend: Client source request; %s, File=\"%s\""), DbgGetClientInfo(), reqfile->GetFileName());
        }
		if (IsSupportingAICH() && m_pDownFileStatus->GetFileAICHHash() == NULL){
			Packet* packet = new Packet(OP_AICHFILEHASHREQ,16,OP_EMULEPROT);
			md4cpy(packet->pBuffer,reqfile->GetFileHash());
			socket->SendPacket(packet,true,true);
		}
	}
    m_pDownFileStatus->SetDownAsked(); // ZZ:DownloadManager
	}
	catch(CString error)
	{
		throw CString(_T(__FUNCTION__) _T("; ")) + error;
	}
}