// ZZ:UploadBandWithThrottler (UDP) -->

#pragma once

#include "NetF/NetF_Tick.h"

// MOD BEGIN netfinity: Upload Throttling State
enum	EUpThrottleState
{
	THROTTLE_KICKSTART,
	THROTTLE_NORMAL,
	THROTTLE_ENDING
};
// MOD END netfinity

struct SocketSentBytes {
    bool    success;
	CBytes	sentBytesStandardPackets;
	CBytes	sentBytesControlPackets;
};

class ThrottledControlSocket
{
public:
    virtual SocketSentBytes SendControlData(CBytes maxNumberOfBytesToSend, CBytes minFragSize) = 0;
};

class ThrottledFileSocket : public ThrottledControlSocket
{
public:
    virtual SocketSentBytes SendFileAndControlData(CBytes maxNumberOfBytesToSend, CBytes minFragSize, bool overrideLimit = false) = 0; // netfinity: Upload (pseudo) rate control
    virtual CTick	GetLastCalledSend() = 0;
    virtual CBytes	GetNeededBytes() = 0;
// MOD BEGIN netfinity: Upload Throttling State
	ThrottledFileSocket() {m_eThrottleState = THROTTLE_NORMAL; m_iLeftInState = 0; m_bNotNeeded = false;}
	EUpThrottleState	m_eThrottleState;
	uint32				m_iLeftInState;
	bool				m_bNotNeeded;
// MOD END netfinity
};

// <-- ZZ:UploadBandWithThrottler (UDP)
